unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SDL_NumLab, Buttons, SDL_Colsel, ExtCtrls,
  SDL_sevenseg;

type
  TForm1 = class(TForm)
    CSelText: TColSel;
    CSelBakg: TColSel;
    SBarInterdig: TScrollBar;
    EdCaption: TEdit;
    SBarMargin: TScrollBar;
    SBarNumDig: TScrollBar;
    Panel1: TPanel;
    Timer1: TTimer;
    My7Seg: TSevenSeg;
    Splitter1: TSplitter;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    RGDisplayMode: TRadioGroup;
    NLabNumDig: TNumLab;
    NLabMargin: TNumLab;
    NLabInterDigDist: TNumLab;
    procedure CSelTextChange(Sender: TObject);
    procedure CSelBakgChange(Sender: TObject);
    procedure SBarInterdigChange(Sender: TObject);
    procedure EdCaptionChange(Sender: TObject);
    procedure SBarMarginChange(Sender: TObject);
    procedure SBarNumDigChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure RGDisplayModeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  SDL_stringl;



(******************************************************************************)
procedure TForm1.CSelTextChange(Sender: TObject);
(******************************************************************************)

begin
My7Seg.ColorText := CSelText.SelColor;
end;

(******************************************************************************)
procedure TForm1.CSelBakgChange(Sender: TObject);
(******************************************************************************)

begin
My7Seg.ColorBackgnd := CSelBakg.SelColor;
end;

(******************************************************************************)
procedure TForm1.SBarInterdigChange(Sender: TObject);
(******************************************************************************)

begin
My7Seg.InterDigDist := SBarInterdig.Position;
NLabInterDigDist.Value := SBarInterdig.Position;
end;

(******************************************************************************)
procedure TForm1.EdCaptionChange(Sender: TObject);
(******************************************************************************)

begin
My7Seg.Caption := EdCaption.Text;
end;

(******************************************************************************)
procedure TForm1.SBarMarginChange(Sender: TObject);
(******************************************************************************)

begin
My7Seg.Margin := SBarMargin.Position;
NLabMargin.Value := SBarMargin.Position;
end;

(******************************************************************************)
procedure TForm1.SBarNumDigChange(Sender: TObject);
(******************************************************************************)

begin
My7Seg.NumDigits := SBarNumDig.Position;
NLabNumDig.Value := SBarNumDig.Position;
end;

(******************************************************************************)
procedure TForm1.Timer1Timer(Sender: TObject);
(******************************************************************************)

begin
case RGDisplayMode.ItemIndex of
  0 : Timer1.Enabled := false;
  1 : begin
      if SDL_sevenseg.IsLightEd
        then My7Seg.Caption := FormatDateTime ('HH.MM.SS', Now)
        else My7Seg.Caption := FormatDateTime ('HH:MM:SS', Now);
      end;
  2 : My7Seg.Caption := strff(86400*Time,6,3);
end;
end;

(******************************************************************************)
procedure TForm1.Splitter1CanResize(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
(******************************************************************************)

begin
if NewSize < 50 then
  Accept := false;
end;

(******************************************************************************)
procedure TForm1.RGDisplayModeClick(Sender: TObject);
(******************************************************************************)

begin
case RGDisplayMode.ItemIndex of
  0 : begin  // static text
      Timer1.Enabled := false;
      EdCaption.Enabled := true;
      My7Seg.Caption := EdCaption.Text;
      end;
  1 : begin  // digital clock
      Timer1.Enabled := true;
      EdCaption.Enabled := false;
      end;
  2 : begin  // stop watch
      Timer1.Enabled := true;
      EdCaption.Enabled := false;
      end;
end;
end;

(******************************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(******************************************************************************)

begin
if not SDL_sevenseg.IsLightEd then
  My7Seg.NumDigits := 8;
end;

end.
